/*
 *   Copyright (c) 1998-2001 T. Kamei (kamei@jsdlab.co.jp)
 *
 *   Permission to use, copy, modify, and distribute this software
 * and its documentation for any purpose is hereby granted provided
 * that the above copyright notice and this permission notice appear
 * in all copies of the software and related documentation.
 *
 *                          NO WARRANTY
 *
 *   THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY WARRANTIES;
 * WITHOUT EVEN THE IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS
 * FOR A PARTICULAR PURPOSE.
 */

#ifndef _arcinfo_h_
# define _arcinfo_h_

class arcinfo
{
  arcinfo *a_prev;
  arcinfo *a_next;
  static arcinfo *a_chain;
public:
  HANDLE a_hunrar;
  char a_arcpath[MAX_PATH + 1];
  DWORD a_mode;
  DWORD a_arcsize;
  WORD a_arcdate;
  WORD a_arctime;
  u_long a_orig_sz;
  u_long a_comp_sz;
  int a_sfx;

  RARHeaderData a_hd;
  int a_first_time;
  int a_valid;
  int a_eof;

  cmdline a_cl;
  glob a_glob;

  arcinfo ();
  ~arcinfo ();
  int open (const char *, DWORD);
  int close ();
  int findnext (INDIVIDUALINFO *, int);
  static arcinfo *find (HARC);
  static void cleanup ();
};

#endif
